import javax.swing.*;
import java.awt.*;
import java.awt.event.ComponentAdapter;
import java.awt.event.ComponentEvent;
import java.util.Random;

public class FormTracktor extends JFrame {
    private JPanel ContentPanel;
    private JButton buttonCreate;
    private JButton buttonLeft;
    private JButton buttonDown;
    private JButton buttonRight;
    private JButton buttonUp;
    public JPanel pictureBox;
    private JButton buttonCreateModif;
    private JComboBox comboBoxStrategy;
    private JButton buttonMakeStep;
    private AbstractStrategy abstractStrategy;
    private DrawningTracktor _tracktor;
    private DrawningExcavator _excavator;

    public FormTracktor(){
        setTitle("Трактор");
        setContentPane(ContentPanel);
        setSize(800, 500);

        // Обработка нажатия кнопки "Создать"
        buttonCreate.addActionListener(e->{
            Random rnd = new Random();
            _tracktor = new DrawningTracktor(
                    rnd.nextInt(100, 300),
                    rnd.nextInt(1000, 2000),
                    new Color(rnd.nextInt(0, 256), rnd.nextInt(0, 256), rnd.nextInt(0, 256)),
                    pictureBox.getWidth(),
                    pictureBox.getHeight(),
                    rnd.nextInt(3,8)
            );
            setData();
        });

        // Обработка нажатия кнопки "Модификация"
        buttonCreateModif.addActionListener(e->{
            Random rnd = new Random();
            _tracktor = new DrawningExcavator(
                    rnd.nextInt(100, 300),
                    rnd.nextInt(1000, 2000),
                    new Color(rnd.nextInt(0, 256), rnd.nextInt(0, 256), rnd.nextInt(0, 256)),
                    rnd.nextBoolean(),
                    rnd.nextBoolean(),
                    new Color(rnd.nextInt(0,256),rnd.nextInt(0,256),rnd.nextInt(0,256)),
                    new Color(rnd.nextInt(0,256),rnd.nextInt(0,256),rnd.nextInt(0,256)),
                    pictureBox.getWidth(),
                    pictureBox.getHeight(),
                    rnd.nextInt(3,8)
            );
            setData();
        });

        buttonUp.addActionListener(e->{
            if (_tracktor != null){
                _tracktor.MoveTransport(Direction.Up);
                repaint();
            }
        });

        buttonLeft.addActionListener(e->{
            if (_tracktor != null){
                _tracktor.MoveTransport(Direction.Left);
                repaint();
            }
        });

        buttonDown.addActionListener(e->{
            if (_tracktor != null){
                _tracktor.MoveTransport(Direction.Down);
                repaint();
            }
        });

        buttonRight.addActionListener(e->{
            if (_tracktor != null){
                _tracktor.MoveTransport(Direction.Right);
                repaint();
            }
        });


        buttonMakeStep.addActionListener(e -> {
            if (_tracktor == null ) {
                return;
            }
            if(comboBoxStrategy.isEditable()) {
                abstractStrategy = switch (comboBoxStrategy.getSelectedIndex()){
                    case 0 -> new MoveToCenter();
                    case 1 -> new MoveToBorder();
                    default -> null;
                };
                if(abstractStrategy == null){
                    return;
                }
                abstractStrategy.setData(new DrawningObjectExcavator(_excavator),this.getWidth(),this.getHeight());
            }
            if(abstractStrategy == null){
                return;
            }
            comboBoxStrategy.setEditable(false);
            abstractStrategy.makeStep();
            repaint();
            if(abstractStrategy.getStatus() == Status.Finish){
                comboBoxStrategy.setEditable(true);
                abstractStrategy = null;
            }
        });
    }

    private void setData() {
        Random rnd = new Random();
        _tracktor.SetPosition(rnd.nextInt(10, 100), rnd.nextInt(10, 100));
        repaint();
    }

    @Override
    public void paint(Graphics g){
        super.paint(g);
        Graphics2D g2d = (Graphics2D)pictureBox.getGraphics();
        if (_tracktor != null){
            _tracktor.DrawTransport(g2d);
        }
    }
}
