
import javax.swing.*;
import java.awt.*;
import java.awt.event.ActionListener;
import java.awt.image.BufferedImage;
import java.util.LinkedList;
import java.util.Random;

public class PictureBoxCollection extends JPanel {
    private TracktorsGenericStorage _storage;
    private LinkedList<DrawningTracktor> removedTracktors;
    private JLabel labelTools;
    private JButton buttonAddTracktor, buttonDeleteTracktor, buttonRefreshCollection, buttonShowDop, buttonAddCollection, buttonDeleteCollection, buttonShowDeleted;
    private JTextField textFieldNumber, textFieldCollectionNumber;
    private JList<String> listStorage;
    private DefaultListModel<String> listModel;
    protected void ReloadCollections()
    {
        int index = listStorage.getSelectedIndex();
        listModel.clear();
        for (String key : _storage.Keys())
        {
            listModel.addElement(key);
        }
        if (!listModel.isEmpty() && (index == -1 || index >= listModel.size()))
        {
            listStorage.setSelectedIndex(0);
        }
        else if (!listModel.isEmpty() && index > -1 && index < listModel.size())
        {
            listStorage.setSelectedIndex(index);
        }

    }
    public PictureBoxCollection() {
        removedTracktors = new LinkedList<>();
        setLayout(null);
        setBounds(0, 0, 800, 750);
        labelTools = new JLabel("Наборы");
        labelTools.setBounds(660, 10, 150, 30);
        add(labelTools);
        textFieldCollectionNumber = new JTextField();
        textFieldCollectionNumber.setBounds(620, 50, 150, 30);
        add(textFieldCollectionNumber);

        buttonAddCollection = new JButton("Добавить набор");
        buttonAddCollection.setFocusable(false);
        buttonAddCollection.setBounds(620, 100, 150, 30);
        buttonAddCollection.addActionListener(e -> {
            String name = textFieldCollectionNumber.getText();
            if (name.length() == 0)
                return;
            _storage.AddSet(name);
            ReloadCollections();
        });
        add(buttonAddCollection);

        listModel = new DefaultListModel<>();
        listStorage = new JList<String>(listModel);
        listStorage.setLayout(null);
        listStorage.setBounds(620, 150, 150, 100);
        add(listStorage);
        listStorage.addListSelectionListener(e -> {
            repaint();
        });

        buttonDeleteCollection = new JButton("Удалить набор");
        buttonDeleteCollection.setFocusable(false);
        buttonDeleteCollection.setBounds(620, 270, 150, 30);
        buttonDeleteCollection.addActionListener(e -> {
            if (listStorage.getSelectedIndex() == -1)
            {
                return;
            }
            if (JOptionPane.showConfirmDialog(null, "Delete object " + listStorage.getSelectedValue() + "?", "Delete", JOptionPane.YES_NO_OPTION) == JOptionPane.NO_OPTION)
            {
                return;
            }
            _storage.DelSet(listStorage.getSelectedValue());
            ReloadCollections();
        });
        add(buttonDeleteCollection);

        _storage = new TracktorsGenericStorage(this.getWidth() - 200, this.getHeight());
        labelTools = new JLabel("Инструменты");
        labelTools.setBounds(660, 300, 150, 30);
        add(labelTools);
        buttonAddTracktor = new JButton("Добавить экскаватор");
        buttonAddTracktor.setFocusable(false);
        buttonAddTracktor.setBounds(620, 350, 150, 30);
        buttonAddTracktor.addActionListener(e -> {
            if (listStorage.getSelectedIndex() == -1)
                return;
            var obj = _storage.get(listStorage.getSelectedValue());
            if (obj == null)
                return;
            FrameExcavator frameExcavator = new FrameExcavator(null);
            frameExcavator.pictureBoxExcavator.buttonSelectTracktor.addActionListener(e1 -> {
                        if (obj.Add(frameExcavator.pictureBoxExcavator.drawingTracktor) != -1) {
                            JOptionPane.showMessageDialog(null, "Объект добавлен", "Информация", JOptionPane.INFORMATION_MESSAGE);
                        } else {
                            JOptionPane.showMessageDialog(null, "Не удалось добавить объект", "Информация", JOptionPane.INFORMATION_MESSAGE);
                        }
                        frameExcavator.dispose();
                        repaint();
                    }
            );
        });
        add(buttonAddTracktor);

        textFieldNumber = new JTextField();
        textFieldNumber.setBounds(620, 400, 150, 30);
        add(textFieldNumber);

        buttonDeleteTracktor = new JButton("Удалить");
        buttonDeleteTracktor.setFocusable(false);
        buttonDeleteTracktor.setBounds(620, 450, 150, 30);
        buttonDeleteTracktor.addActionListener(e -> {
            if (listStorage.getSelectedIndex() == -1)
                return;
            var obj = _storage.get(listStorage.getSelectedValue());
            if (obj == null)
                return;
            if (JOptionPane.showConfirmDialog(null, "Удалить объект?", "Удаление", JOptionPane.YES_NO_OPTION) == JOptionPane.NO_OPTION) {
                return;
            }
            for (char it : textFieldNumber.getText().toCharArray())
                if (it < '0' || it > '9') {
                    JOptionPane.showMessageDialog(null, "Не удалось удалить объект", "Информация", JOptionPane.INFORMATION_MESSAGE);
                    return;
                }
            if (textFieldNumber.getText().length() == 0) {
                JOptionPane.showMessageDialog(null, "Не удалось удалить объект", "Информация", JOptionPane.INFORMATION_MESSAGE);
                return;
            }

            int pos = Integer.parseInt(textFieldNumber.getText());
            DrawningTracktor removed = null;
            removed = obj.remove(pos);
            if (removed != null) {
                JOptionPane.showMessageDialog(null, "Объект удален", "Информация", JOptionPane.INFORMATION_MESSAGE);
                removedTracktors.add(removed);
            } else {
                JOptionPane.showMessageDialog(null, "Не удалось удалить объект", "Информация", JOptionPane.INFORMATION_MESSAGE);
            }
            repaint();
        });
        add(buttonDeleteTracktor);

        buttonRefreshCollection = new JButton("Обновить коллекцию");
        buttonRefreshCollection.setFocusable(false);
        buttonRefreshCollection.setBounds(620, 500, 150, 30);
        buttonRefreshCollection.addActionListener(e -> repaint());
        add(buttonRefreshCollection);

        buttonShowDeleted = new JButton("Удаленные");
        buttonShowDeleted.setFocusable(false);
        buttonShowDeleted.setBounds(620, 550, 150, 30);
        buttonShowDeleted.addActionListener(e -> {
            if (removedTracktors.size() == 0){
                JOptionPane.showMessageDialog(null, "Коллекция пуста", "Информация", JOptionPane.INFORMATION_MESSAGE);
                return;
            }
            var tracktor = removedTracktors.removeLast();
            FrameExcavator frameExcavator = new FrameExcavator(tracktor);
            frameExcavator.setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
        });
        add(buttonShowDeleted);
        buttonShowDop = new JButton("Показать доп");
        buttonShowDop.setFocusable(false);
        buttonShowDop.setBounds(620, 650, 150, 30);
        buttonShowDop.addActionListener(e -> new FrameDop());
        add(buttonShowDop);


        setPreferredSize(new Dimension(800, 750));
    }

    @Override
    protected void paintComponent(Graphics g) {
        super.paintComponent(g);
        Graphics2D g2d = (Graphics2D) g;
        if (listStorage.getSelectedIndex() == -1)
            return;
        var obj = _storage.get(listStorage.getSelectedValue());
        if (obj == null)
            return;
        if (obj.ShowTracktors() == null)
            return;
        g2d.drawImage(obj.ShowTracktors(), 0, 0, null);
    }
}
