import java.util.ArrayList;
import java.util.Iterator;
import java.util.NoSuchElementException;
public class SetGeneric<T extends  Object> {
    public final ArrayList<T> _places;
    private final int _maxCount;
    public SetGeneric(int count){
        _maxCount = count;
        _places = new ArrayList<>();
    }
    public int Insert(T tracktor){
        return Insert(tracktor,0);
    }
    public int Insert(T tracktor, int position){
        if(position < 0 || position >= _maxCount)
            return -1;
        _places.add(position, tracktor);
        return position;
    }
    public boolean Remove(int position){
        if(position < 0 || position >= _places.size()){
            return false;
        }
        _places.remove(position);
        return true;
    }
    public T Get(int position){
        if(position < 0 || position >= _places.size()){
            return null;
        }
        return  _places.get(position);
    }
    public Iterable<T> GetTracktors(final Integer maxTracktors){
        return new Iterable<T>() {
            @Override
            public Iterator<T> iterator() {
                return new Iterator<T>() {
                    private  int currentIndex;
                    private int count = 0;
                    @Override
                    public boolean hasNext() {
                        return currentIndex < _places.size() && (maxTracktors == null || count < maxTracktors);
                    }

                    @Override
                    public T next() {
                        if (hasNext()){
                            count++;
                            return _places.get(currentIndex++);
                        }
                        throw new NoSuchElementException();
                    }
                    @Override
                    public void remove(){
                        throw new UnsupportedOperationException();
                    }
                };
            }
        };
    }
}
