import java.util.ArrayList;
import java.util.HashMap;

public class TracktorsGenericStorage {
    final HashMap<String, TracktorsGenericCollection<DrawningTracktor, DrawningObjectExcavator>> _tracktorStorages;
    public ArrayList<String> Keys()
    {
        return new ArrayList<>(_tracktorStorages.keySet());
    }
    private final int _pictureWidth;
    private final int _pictureHeight;
    public TracktorsGenericStorage(int pictureWidth, int pictureHeight)
    {
        _pictureHeight = pictureHeight;
        _pictureWidth = pictureWidth;
        _tracktorStorages = new HashMap<>();
    }
    public void AddSet(String name)
    {
        if (Keys().contains(name))
            return;
        _tracktorStorages.put(name, new TracktorsGenericCollection<>(_pictureWidth, _pictureHeight));
    }
    public void DelSet(String name)
    {
        if (!Keys().contains(name))
            return;
        _tracktorStorages.remove(name);
    }

    public TracktorsGenericCollection<DrawningTracktor, DrawningObjectExcavator> get(String ind)
    {
        if (Keys().contains(ind))
            return _tracktorStorages.get(ind);
        return null;
    }
    public DrawningObjectExcavator get(String name, int ind)
    {
        if (!Keys().contains(name))
            return null;
        return _tracktorStorages.get(name).GetU(ind);
    }
}